`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA02) - 2. labor                                   *
//*                                                                            *
//* 3. feladat: Hierarchikus tervezs bemutatsa. 4 bites sszead ksztse   *
//* teljes sszeadkbl.                                                       *
//******************************************************************************
module lab02_3(
   input  wire [7:0] sw,
   output wire [7:0] ld
);

//Az sszeadandk a DIP kapcsol als s fels 4 bitjei.
wire [3:0] a = sw[3:0];
wire [3:0] b = sw[7:4];

//Az sszeg.
wire [3:0] s;

//Az tvitel bitek. Mi legyen a legkisebb helyilrtkre bemen tvitel bit?
wire [4:0] c;

assign c[0] = 1'b0;

//Pldnyostsunk 4 teljes sszead modult s kapcsoljuk ssze ket az tvitel
//biteken keresztl.
fadd add0(.a(a[0]), .b(b[0]), .ci(c[0]), .s(s[0]), .co(c[1]));
fadd add1(.a(a[1]), .b(b[1]), .ci(c[1]), .s(s[1]), .co(c[2]));
fadd add2(.a(a[2]), .b(b[2]), .ci(c[2]), .s(s[2]), .co(c[3]));
fadd add3(.a(a[3]), .b(b[3]), .ci(c[3]), .s(s[3]), .co(c[4]));

//A kimenetek meghajtsa. A nem kasznlt LED-eket kikapcsoljuk.
//a) Csak a 4 bites sszeget jelentjk meg az als 4 LED-en. 
//b) Kivezetjk a c[4]-et is, mint az 5. sszeg bitet.
assign ld[3:0] = s;
assign ld[4]   = 1'b0;             //a)
//assign ld[4]   = c[4];             //b)
assign ld[7:5] = 3'b000;

endmodule
