`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA02) - 2. labor                                   *
//*                                                                            *
//* 2. feladat: 4 vltozs elemi logikai fggvnyek.                           *
//******************************************************************************
module lab02_2(
   input  wire [3:0] sw,
   output wire [7:0] ld
);

//LD0: az SW bitek AND kapcsolata.
//assign ld[0] = sw[0] & sw[1] & sw[2] & sw[3];
assign ld[0] = &sw;

//LD1: az SW bitek OR lapcsolata.
//assign ld[0] = sw[0] | sw[1] | sw[2] | sw[3];
assign ld[0] = |sw;

//LD2: az SW bitek NOR lapcsolata.
//assign ld[0] = ~(sw[0] | sw[1] | sw[2] | sw[3]);
assign ld[0] = ~|sw;

//LD3: az SW bitek XOR lapcsolata.
//assign ld[0] = sw[0] ^ sw[1] ^ sw[2] ^ sw[3];
assign ld[0] = ^sw;

//LD4: az SW bitek XNOR lapcsolata.
//assign ld[0] = ~(sw[0] ^ sw[1] ^ sw[2] ^ sw[3]);
assign ld[0] = ~^sw;

//A nem kasznlt LED-eket kikapcsoljuk.
assign ld[7:5] = 3'b000;

endmodule
