`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA02) - 2. labor                                   *
//*                                                                            *
//* Tesztkrnyezet a 3. feladathoz.                                           *
//******************************************************************************
module lab02_3_test;

	// Inputs
	reg [7:0] sw;

	// Outputs
	wire [7:0] ld;

	// Instantiate the Unit Under Test (UUT)
	lab02_3 uut (
		.sw(sw), 
		.ld(ld)
	);
   
   //Az sszeg (a nem hasznlt fels LED biteket itt eldobjuk).
   //a) 4 bites
   //b) 5 bites (kiegsztve a legnagyobb helyirtkbl kijv tvitel bittel).
   wire [3:0] sum = ld[3:0];
   
   integer i;

	initial begin
		// Initialize Inputs
		sw = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		//100 ns-onknt adjuk az sw bemenetre a lehetsges bemeneti
      //kombincikat. Clszer for ciklust hasznlni ehhez.
      for (i = 0; i < 256; i = i + 1)
      begin
         sw = i;
         #100;
      end
	end
      
endmodule
